From: Markus Koschany <apo@debian.org>
Date: Thu, 1 Nov 2012 01:38:45 +0100
Subject: Fix unix paths and Makefile
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

This patch fixes various path issues and the Makefile. It was created
by merging all patches which existed before version 1.5-5. The original
authors of those patches were Gürkan Sengün and jusTiCe8.

Since version 1.5-5 the patch which added commandline options to
supertransball2 is gone. It didn't work anyway. The Makefile
has been further improved. Now supertransball2 doesn't link against
libsdl_sound anymore which was superfluous.
---
 sources/Makefile                  | 21 ++++++++++++++++-----
 sources/configuration.cpp         |  7 +++++++
 sources/encoder.cpp               | 12 +++++++++++-
 sources/game.cpp                  | 10 +++++++++-
 sources/main.cpp                  | 32 +++++++++++++++++++++++++++++++-
 sources/maps.cpp                  |  4 ++++
 sources/replays.cpp               |  8 ++++++++
 sources/state_changepack.cpp      |  8 ++++++--
 sources/state_chooseship.cpp      |  2 +-
 sources/state_endsequence.cpp     |  2 +-
 sources/state_game.cpp            | 10 +++++-----
 sources/state_gameover.cpp        |  2 +-
 sources/state_instructions.cpp    |  2 +-
 sources/state_interphase.cpp      |  7 ++++++-
 sources/state_keyredefinition.cpp |  2 +-
 sources/state_levelfinished.cpp   |  2 +-
 sources/state_logo.cpp            |  2 +-
 sources/state_mainmenu.cpp        |  6 +++++-
 sources/state_replay.cpp          | 10 +++++-----
 sources/state_replaymanager.cpp   | 11 ++++++++++-
 sources/state_typetext.cpp        |  2 +-
 21 files changed, 131 insertions(+), 31 deletions(-)

diff --git a/sources/Makefile b/sources/Makefile
index 08a898f..c8d7a72 100644
--- a/sources/Makefile
+++ b/sources/Makefile
@@ -1,3 +1,4 @@
+TARGET=supertransball2
 OBJS := \
 	auxiliar.o           configuration.o     encoder.o \
 	enemies.o            fonts.o       	 game.o \
@@ -9,16 +10,26 @@ OBJS := \
 	state_replay.o       state_replaymanager.o \
 	state_typetext.o     tiles.o             transball.o \
 
-all: stransball2
+all: $(TARGET)
+
 
 %.o: %.cpp
 	c++ -c -g3 -O3 $< -o $@ `sdl-config --cflags` -I/usr/local/include/SDL
 
 # dynamically linked binary:
-stransball2: $(OBJS)
-	c++ $^ -o $@ `sdl-config --libs` -lSDL_image -lSDL_mixer -lSDL_sound -lSDL_sound -lSGE -I/usr/local/include/SDL
-	mv ./stransball2 ..
+$(TARGET): $(OBJS)
+	c++ $^ -o $@ `sdl-config --libs` -lSDL_image -lSDL_mixer -lSGE -I/usr/local/include/SDL
+	mv ./$(TARGET) ..
 
 clean:
-	rm -f stransball2
+	rm -f ../$(TARGET)
 	rm -f *.o
+
+install:
+	install -o root -g games -m 755 ../$(TARGET) $(DESTDIR)/usr/games
+
+install-data:
+	install -o root -g games -m 644 ../demos/* $(DESTDIR)/usr/share/games/supertransball2/demos/
+	install -o root -g games -m 644 ../sound/* $(DESTDIR)/usr/share/games/supertransball2/sound/
+	cp -r ../maps/* $(DESTDIR)/usr/share/games/supertransball2/maps/
+	install -o root -g games -m 644 ../graphics/* $(DESTDIR)/usr/share/games/supertransball2/graphics/
diff --git a/sources/configuration.cpp b/sources/configuration.cpp
index cb19a04..a84410b 100644
--- a/sources/configuration.cpp
+++ b/sources/configuration.cpp
@@ -1,4 +1,5 @@
 #include "stdio.h"
+#include <unistd.h>
 
 #include "SDL.h"
 
@@ -9,13 +10,17 @@ extern SDLKey PAUSE_KEY;
 extern bool fullscreen;
 extern int PIXEL_SIZE;
 
+extern char *datadir;
+extern char *confdir;
 
 bool load_configuration(void)
 {
 	int a,b,c,d,e,f,g;
 	FILE *fp;
 
+	chdir(confdir);
 	fp=fopen("transball.cfg","r");
+	chdir(datadir);
 
 	if (fp==0) return false;
 
@@ -46,7 +51,9 @@ void save_configuration(void)
 {
 	FILE *fp;
 
+	chdir(confdir);
 	fp=fopen("transball.cfg","w");
+	chdir(datadir);
 	
 	if (fp==0) return;
 
diff --git a/sources/encoder.cpp b/sources/encoder.cpp
index 1ed931f..b718f3a 100644
--- a/sources/encoder.cpp
+++ b/sources/encoder.cpp
@@ -1,5 +1,9 @@
 #include "stdio.h"
-
+#include "unistd.h"
+
+extern char *confdir;
+extern char *datadir;
+
 void encode(char *in,char *out)
 {
 	int seed[16]={1,7,3,9,34,1,24,1, 
@@ -9,8 +13,11 @@ void encode(char *in,char *out)
 	FILE *fpin;
 	FILE *fpout;
 
+	chdir(datadir);
 	fpin=fopen(in,"rb");
+	chdir(confdir);
 	fpout=fopen(out,"wb");
+	chdir(datadir);
 	if (fpin==0 || fpout==0) return;
 
 	do{
@@ -40,8 +47,11 @@ void decode(char *in,char *out)
 	FILE *fpin;
 	FILE *fpout;
 
+	chdir(datadir);
 	fpin=fopen(in,"rb");
+	chdir(confdir);
 	fpout=fopen(out,"wb");
+	chdir(datadir);
 	if (fpin==0 || fpout==0) return;
 
 	do{
diff --git a/sources/game.cpp b/sources/game.cpp
index 7547faf..a8cb728 100644
--- a/sources/game.cpp
+++ b/sources/game.cpp
@@ -8,6 +8,7 @@
 #endif
 
 #include <stdio.h>
+#include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include "SDL/SDL.h"
@@ -84,6 +85,9 @@ extern TRANSBALL *game;
 /* Frames per second counter: */ 
 extern int frames_per_sec;
 
+extern char *datadir;
+extern char *confdir;
+
 FILE *replayfile;
 int replaynum;
 int replay_source=0;
@@ -92,7 +96,7 @@ int replay_source=0;
 SDLKey THRUST_KEY=SDLK_q,ANTITHRUST_KEY=SDLK_a,LEFT_KEY=SDLK_o,RIGHT_KEY=SDLK_p;
 SDLKey FIRE_KEY=SDLK_SPACE,ATRACTOR_KEY=SDLK_RETURN;
 SDLKey PAUSE_KEY=SDLK_F1;
-bool pause=false;
+bool pause2=false;
 
 unsigned char old_keyboard[SDLK_LAST];
 SDL_Surface *image=0,*image2=0;	/* For the tittle screen, etc. */ 
@@ -133,8 +137,10 @@ bool gamecycle(SDL_Surface *screen,int sx,int sy)
 		strcpy(tmp,"maps/");
 		strcat(tmp,levelpack);
 
+		chdir(datadir);
 		decode(tmp,"decoding.tmp");
 
+		chdir(confdir);
 		fp=fopen("decoding.tmp","r+");
 		if (fp!=0) {
 			fscanf(fp,"%i",&NLEVELS);
@@ -167,6 +173,8 @@ bool gamecycle(SDL_Surface *screen,int sx,int sy)
 
 	if (NLEVELS==-1) return false;
 
+	chdir(datadir);
+
 	switch(STATE) {
 	case 0:	if (!state_logo_cycle(screen,sx,sy,keyboard)) return false;
 			break;
diff --git a/sources/main.cpp b/sources/main.cpp
index 6aac085..7f94891 100644
--- a/sources/main.cpp
+++ b/sources/main.cpp
@@ -11,6 +11,11 @@
 #include "SDL/SDL.h"
 #include "SDL_mixer.h"
 #include "sge.h"
+
+#include <string.h>
+#include <unistd.h>
+#include <sys/stat.h>
+#include <sys/types.h>
 
 #include "fonts.h"
 #include "list.h"
@@ -26,7 +31,7 @@ int SCREEN_X=320;
 int SCREEN_Y=240;
 int PIXEL_SIZE=1;
 int COLOUR_DEPTH=32;
-
+
 #ifdef _WIN32
 //bool fullscreen=true;
 bool fullscreen=true;
@@ -42,6 +47,8 @@ int frames_per_sec=0;
 int frames_per_sec_tmp=0;
 int init_time=0;
 
+char *datadir="/usr/share/games/supertransball2/";
+char *confdir;
 
 /* Surfaces: */ 
 SDL_Surface *screen_sfc=0,*buffer_screen_sfc=0;
@@ -125,6 +132,29 @@ int main(int argc, char** argv)
 {
 	setupTickCount();
 #endif
+
+        mode_t mode;
+        FILE *cfg;
+	confdir=(char*)malloc(strlen(getenv("HOME"))+50); strcpy(confdir,getenv("HOME"));
+        strcat(confdir,"/.supertransball2");
+	mode=S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IXGRP;
+	mkdir(confdir,mode);
+	chdir(confdir);
+	mkdir("replays",mode);
+	mkdir("high",mode);
+
+	cfg=fopen("transball.cfg", "r");
+	if (!cfg)
+	{
+		cfg=fopen("transball.cfg", "w");
+                fprintf(cfg,"%s","113 97 111 112 32 13 282");
+	}
+
+	fclose(cfg);
+	
+	printf("Configuration: %s\n",confdir);
+        printf("Data: %s\n",datadir);
+        chdir(datadir);
 
 	int time,act_time;
 	SDL_Event event;
diff --git a/sources/maps.cpp b/sources/maps.cpp
index 4c6a278..fa95368 100644
--- a/sources/maps.cpp
+++ b/sources/maps.cpp
@@ -1,4 +1,5 @@
 #include <stdio.h>
+#include <unistd.h>
 #include <stdlib.h>
 #include "SDL/SDL.h"
 #include "SDL_mixer.h"
@@ -13,6 +14,8 @@
 #define EMPTY_ROWS	8
 #define FACTOR	512
 
+extern char *datadir;
+extern char *confdir;
 
 TRANSBALL_MAP::TRANSBALL_MAP(char *file)
 {
@@ -25,6 +28,7 @@ TRANSBALL_MAP::TRANSBALL_MAP(char *file)
 	S_enemyhit=0;
 	S_switch=0;
 
+	chdir(datadir);
 	fp=fopen(file,"r");
 	if (fp==0) {
 		sx=0;
diff --git a/sources/replays.cpp b/sources/replays.cpp
index 1d4e885..5d95fc5 100644
--- a/sources/replays.cpp
+++ b/sources/replays.cpp
@@ -1,5 +1,8 @@
 #include "stdio.h"
+#include "unistd.h"
 
+extern char* datadir;
+extern char* confdir;
 
 int replay_parameters(char *file, int *ship, int *length, char *levelname)
 {
@@ -8,7 +11,9 @@ int replay_parameters(char *file, int *ship, int *length, char *levelname)
 	int l,end;
 	int v1,v2,fuel;
 
+        chdir(confdir);
 	fp=fopen(file,"rb");
+        chdir(datadir);
 	if (fp==0) return -1;
 	v1=fgetc(fp);
 	v2=fgetc(fp);
@@ -35,8 +40,11 @@ void replay_copy(char *f1,char *f2)
 
 	FILE *fp1,*fp2;
 
+        chdir(confdir);
 	fp1=fopen(f1,"rb");
+        /* chdir(confdir); */
 	fp2=fopen(f2,"wb");
+        chdir(datadir);
 
 	do{
 		fputc(fgetc(fp1),fp2);
diff --git a/sources/state_changepack.cpp b/sources/state_changepack.cpp
index 41c28da..ec73aba 100644
--- a/sources/state_changepack.cpp
+++ b/sources/state_changepack.cpp
@@ -8,6 +8,7 @@
 #endif
 
 #include <stdio.h>
+#include "unistd.h"
 #include <stdlib.h>
 #include <string.h>
 #include "SDL/SDL.h"
@@ -43,7 +44,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -63,6 +64,8 @@ extern char *leveltext[MAXLEVELS];
 extern char *levelcode[MAXLEVELS];
 extern int initialfuel[MAXLEVELS];
 
+extern char *confdir;
+extern char *datadir;
 
 bool state_changepack_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 {
@@ -97,7 +100,8 @@ bool state_changepack_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *key
 #else
                         DIR *dp;
                         struct dirent *ep;
-		  
+			
+			chdir(datadir);
                         dp = opendir ("maps");
                         if (dp != NULL)
                         {
diff --git a/sources/state_chooseship.cpp b/sources/state_chooseship.cpp
index 6de61e2..5a25c04 100644
--- a/sources/state_chooseship.cpp
+++ b/sources/state_chooseship.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_endsequence.cpp b/sources/state_endsequence.cpp
index 963a9f7..813ae67 100644
--- a/sources/state_endsequence.cpp
+++ b/sources/state_endsequence.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_game.cpp b/sources/state_game.cpp
index 10f515f..56f2321 100644
--- a/sources/state_game.cpp
+++ b/sources/state_game.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -69,11 +69,11 @@ bool state_game_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 	int retval=0;
 
 	if (keyboard[PAUSE_KEY] && !old_keyboard[PAUSE_KEY]) {
-		if (pause) pause=false;
-			  else pause=true;
+		if (pause2) pause2=false;
+			  else pause2=true;
 	} /* if */ 
 
-	if (!pause) {
+	if (!pause2) {
 		retval=game->cycle(keyboard);
 		if (replayfile!=0) {
 			fputc(keyboard[THRUST_KEY],replayfile);
@@ -88,7 +88,7 @@ bool state_game_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 
 	game->render(screen,sx,sy);
 
-	if (pause) {
+	if (pause2) {
 		surface_fader(screen,0.5F,0.5F,0.5F,-1,0);
 		font_print(sx/2,sy/2-16,"PAUSE",screen);
 	} else {
diff --git a/sources/state_gameover.cpp b/sources/state_gameover.cpp
index 7c02012..4d9f5c4 100644
--- a/sources/state_gameover.cpp
+++ b/sources/state_gameover.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_instructions.cpp b/sources/state_instructions.cpp
index acd6e03..fb67d09 100644
--- a/sources/state_instructions.cpp
+++ b/sources/state_instructions.cpp
@@ -41,7 +41,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_interphase.cpp b/sources/state_interphase.cpp
index 41a7810..52d10bd 100644
--- a/sources/state_interphase.cpp
+++ b/sources/state_interphase.cpp
@@ -8,6 +8,7 @@
 #endif
 
 #include <stdio.h>
+#include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include "SDL/SDL.h"
@@ -43,7 +44,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -63,6 +64,8 @@ extern char *leveltext[MAXLEVELS];
 extern char *levelcode[MAXLEVELS];
 extern int initialfuel[MAXLEVELS];
 
+extern char *datadir;
+extern char *confdir;
 
 bool state_interphase_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 {
@@ -92,7 +95,9 @@ bool state_interphase_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *key
 			if (game=0) delete game;
 			game=new TRANSBALL("graphics/","sound/","maps/",initialfuel[level],levelnames[level],ship_type);
 			sprintf(tmp,"replays/replay%.3i.rpl",replaynum++);
+			chdir(confdir);
 			replayfile=fopen(tmp,"wb+");
+			chdir(datadir);
 			fputc(32,replayfile);
 			fputc(0,replayfile);
 			/* level name: */ 
diff --git a/sources/state_keyredefinition.cpp b/sources/state_keyredefinition.cpp
index b062e62..64b7709 100644
--- a/sources/state_keyredefinition.cpp
+++ b/sources/state_keyredefinition.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_levelfinished.cpp b/sources/state_levelfinished.cpp
index 31ccd8a..863efdc 100644
--- a/sources/state_levelfinished.cpp
+++ b/sources/state_levelfinished.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_logo.cpp b/sources/state_logo.cpp
index 1487e8b..600f305 100644
--- a/sources/state_logo.cpp
+++ b/sources/state_logo.cpp
@@ -41,7 +41,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
diff --git a/sources/state_mainmenu.cpp b/sources/state_mainmenu.cpp
index e689caf..79f9f67 100644
--- a/sources/state_mainmenu.cpp
+++ b/sources/state_mainmenu.cpp
@@ -8,6 +8,7 @@
 #endif
 
 #include <stdio.h>
+#include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include "SDL/SDL.h"
@@ -41,7 +42,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -57,6 +58,8 @@ extern List<char> levelpacks;
 extern int act_levelpack;
 extern char levelpack[256];
 
+extern char *datadir;
+extern char *confdir;
 
 bool state_mainmenu_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 {
@@ -157,6 +160,7 @@ bool state_mainmenu_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keybo
 			tittle_alpha=255;
 
 			sprintf(tmp,"demos/demo%i.rpl",((rand()%40)/10)+1);
+			chdir(datadir);
 			replayfile=fopen(tmp,"rb");
 			v1=fgetc(replayfile);
 			v2=fgetc(replayfile);	// To maintain compatibility with a previous version
diff --git a/sources/state_replay.cpp b/sources/state_replay.cpp
index a38ac37..d8c172f 100644
--- a/sources/state_replay.cpp
+++ b/sources/state_replay.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -71,11 +71,11 @@ bool state_replay_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboar
 	SUBSTATE++;
 
 	if (keyboard[PAUSE_KEY] && !old_keyboard[PAUSE_KEY]) {
-		if (pause) pause=false;
-			  else pause=true;
+		if (pause2) pause2=false;
+			  else pause2=true;
 	} /* if */ 
 
-	if (!pause) {
+	if (!pause2) {
 		int i;
 		unsigned char tmp[SDLK_LAST];
 		for(i=0;i<SDLK_LAST;i++) tmp[i]=0;
@@ -91,7 +91,7 @@ bool state_replay_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboar
 
 	game->render(screen,sx,sy);
 
-	if (pause) {
+	if (pause2) {
 		surface_fader(screen,0.5F,0.5F,0.5F,-1,0);
 		font_print(sx/2,sy/2-16,"PAUSE",screen);
 	} else {
diff --git a/sources/state_replaymanager.cpp b/sources/state_replaymanager.cpp
index e767de2..14a7e05 100644
--- a/sources/state_replaymanager.cpp
+++ b/sources/state_replaymanager.cpp
@@ -8,6 +8,7 @@
 #endif
 
 #include <stdio.h>
+#include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include "SDL/SDL.h"
@@ -43,7 +44,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
@@ -63,6 +64,8 @@ extern char *leveltext[MAXLEVELS];
 extern char *levelcode[MAXLEVELS];
 extern int initialfuel[MAXLEVELS];
 
+extern char *datadir;
+extern char *confdir;
 
 bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *keyboard)
 {
@@ -103,6 +106,7 @@ bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *
 		DIR *dp;
 		struct dirent *ep;
 		  
+		chdir(confdir);
 		if (replay_source==0) dp = opendir ("replays");
 						 else dp = opendir ("high");
 		if (dp != NULL)
@@ -124,6 +128,7 @@ bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *
 			 }
 			(void) closedir (dp);
 		 }
+		chdir(datadir);
 #endif                          
 		first_file=0;
 		act_file=0;		
@@ -210,7 +215,9 @@ bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *
 
 				if (replay_source==0) sprintf(tmp,"replays/%s",files[act_file]);
 								 else sprintf(tmp,"high/%s",files[act_file]);
+				chdir(confdir);
 				replayfile=fopen(tmp,"rb");
+				chdir(datadir);
 				v1=fgetc(replayfile);
 				v2=fgetc(replayfile);	// To maintain compatibility with a previous version
 
@@ -309,6 +316,7 @@ bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *
 				DIR *dp;
 				struct dirent *ep;
 				  
+				chdir(confdir);
 				dp = opendir ("replays");
 				if (dp != NULL)
 				 {
@@ -329,6 +337,7 @@ bool state_replaymanager_cycle(SDL_Surface *screen,int sx,int sy,unsigned char *
 					 }
 					(void) closedir (dp);
 				 }
+				chdir(datadir);
 #endif                  
 				
 				/* Check if this replay is a highscore: */ 
diff --git a/sources/state_typetext.cpp b/sources/state_typetext.cpp
index da45793..c9c7995 100644
--- a/sources/state_typetext.cpp
+++ b/sources/state_typetext.cpp
@@ -43,7 +43,7 @@ extern int replay_source;
 extern SDLKey THRUST_KEY,ANTITHRUST_KEY,LEFT_KEY,RIGHT_KEY;
 extern SDLKey FIRE_KEY,ATRACTOR_KEY;
 extern SDLKey PAUSE_KEY;
-extern bool pause;
+extern bool pause2;
 extern unsigned char old_keyboard[SDLK_LAST];
 extern SDL_Surface *image,*image2;
 extern char edit_text[80];
